window.Gleam.initSearch([{"doc":"fireball","title":"fireball","content":"# fireball\n\n[![Package Version](https://img.shields.io/hexpm/v/fireball)](https://hex.pm/packages/fireball)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/fireball/)\n\n```sh\ngleam add fireball@1\n```\n```gleam\nimport gleam/io\n\nimport fireball\n\npub fn main() {\n  //Get a document from your database\n  let assert Ok(my_doc) = firebase.get_doc(apikey: &quot;my_key&quot;, apiver: &quot;v1beta1&quot;, database: &quot;(default)&quot;, doc: &quot;path/to/my_doc/without/leading/slash&quot;, proj_id: &quot;my_project_id&quot;)\n\n  //Print some data from it!\n  io.println(my_doc.data)\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/fireball&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\n```\n","url":"index.html"},{"doc":"fireball","title":"Collection","content":"pub type Collection {\n  Collection(location: String, err: String)\n}\nFirestore collection type\nCollection(location: String, err: String)\n\n\nSynonyms:\nfireball.Collection\nfireball Collection","url":"fireball.html#Collection"},{"doc":"fireball","title":"FireballDocument","content":"pub type FireballDocument {\n  FireballDocument(data: String)\n}\nFirestore document type\nFireballDocument(data: String)\n\n\nSynonyms:\nfireball.FireballDocument\nfireball FireballDocument","url":"fireball.html#FireballDocument"},{"doc":"fireball","title":"FireballError","content":"pub type FireballError {\n  FireballError(err: String)\n}\n\nFireballError(err: String)\n\n\nSynonyms:\nfireball.FireballError\nfireball FireballError","url":"fireball.html#FireballError"},{"doc":"fireball","title":"FireballStorage","content":"pub type FireballStorage {\n  FireballStorage(path: String)\n}\n\nFireballStorage(path: String)\n\n\nSynonyms:\nfireball.FireballStorage\nfireball FireballStorage","url":"fireball.html#FireballStorage"},{"doc":"fireball","title":"UploadData","content":"pub type UploadData {\n  UploadData(\n    name: String,\n    bucket: String,\n    generation: String,\n    metageneration: String,\n    content_type: String,\n    time_created: String,\n    updated: String,\n    storage_class: String,\n    size: String,\n    md5_hash: String,\n    content_encoding: String,\n    content_disposition: String,\n    crc32c: String,\n    etag: String,\n    download_tokens: String,\n  )\n}\nA type representing the JSON returning when uploading an object to Google Firebase Storage\nUploadData(\n  name: String,\n  bucket: String,\n  generation: String,\n  metageneration: String,\n  content_type: String,\n  time_created: String,\n  updated: String,\n  storage_class: String,\n  size: String,\n  md5_hash: String,\n  content_encoding: String,\n  content_disposition: String,\n  crc32c: String,\n  etag: String,\n  download_tokens: String,\n)\n\n\nSynonyms:\nfireball.UploadData\nfireball UploadData","url":"fireball.html#UploadData"},{"doc":"fireball","title":"doc_to_json","content":"pub fn doc_to_json(doc doc: FireballDocument) -&gt; String\nFunction to transform a document into JSON\nSynonyms:\nfireball.doc_to_json\nfireball doc_to_json","url":"fireball.html#doc_to_json"},{"doc":"fireball","title":"doc_to_list","content":"pub fn doc_to_list(doc doc: FireballDocument) -&gt; List(String)\nFunction to transform a document into a list of strings\nSynonyms:\nfireball.doc_to_list\nfireball doc_to_list","url":"fireball.html#doc_to_list"},{"doc":"fireball","title":"doc_to_string","content":"pub fn doc_to_string(doc doc: FireballDocument) -&gt; String\nFunction to transform a document into a semi-colon string\nSynonyms:\nfireball.doc_to_string\nfireball doc_to_string","url":"fireball.html#doc_to_string"},{"doc":"fireball","title":"doc_to_tuple","content":"pub fn doc_to_tuple(doc doc: FireballDocument) -&gt; #(String)\nFunction to transform a document into a tuple of strings\nSynonyms:\nfireball.doc_to_tuple\nfireball doc_to_tuple","url":"fireball.html#doc_to_tuple"},{"doc":"fireball","title":"get_doc","content":"pub fn get_doc(\n  apikey apikey: String,\n  apiver apiver: String,\n  database database: String,\n  doc doc: String,\n  proj_id proj_id: String,\n) -&gt; Result(FireballDocument, FireballError)\nget_doc function to retrieve a document from Google&#39;s Firestore Database\nSynonyms:\nfireball.get_doc\nfireball get_doc","url":"fireball.html#get_doc"},{"doc":"fireball","title":"get_file","content":"pub fn get_file(\n  apiver apiver: String,\n  obj_path obj_path: String,\n  proj_id proj_id: String,\n  token token: String,\n  content_type content_type: String,\n) -&gt; Result(FireballStorage, FireballError)\nget_file function is used to retrieve a single file from Google&#39;s Firestore Storage\nSynonyms:\nfireball.get_file\nfireball get_file","url":"fireball.html#get_file"},{"doc":"fireball","title":"json_to_upload_data","content":"pub fn json_to_upload_data(\n  input input: Dynamic,\n) -&gt; Result(UploadData, List(DecodeError))\nA function to turn JSON into UploadData - adapted from https://github.com/emergent/decode-json-examples/blob/main/test/decode_json_test.gleam\nSynonyms:\nfireball.json_to_upload_data\nfireball json_to_upload_data","url":"fireball.html#json_to_upload_data"},{"doc":"fireball","title":"post_doc","content":"pub fn post_doc(\n  apikey apikey: String,\n  apiver apiver: String,\n  database database: String,\n  collection_path collection_path: String,\n  doc_path doc_path: String,\n  input_doc input_doc: FireballDocument,\n  proj_id proj_id: String,\n) -&gt; Result(FireballDocument, FireballError)\nput_file function to create a document in Google&#39;s Firestore Database\nSynonyms:\nfireball.post_doc\nfireball post_doc","url":"fireball.html#post_doc"},{"doc":"fireball","title":"post_doc_from_file","content":"pub fn post_doc_from_file(\n  apikey apikey: String,\n  apiver apiver: String,\n  database database: String,\n  collection_path collection_path: String,\n  doc_path doc_path: String,\n  input_doc input_doc: String,\n  proj_id proj_id: String,\n) -&gt; Result(FireballDocument, FireballError)\nput_file function to create a document in Google&#39;s Firestore Database\nSynonyms:\nfireball.post_doc_from_file\nfireball post_doc_from_file","url":"fireball.html#post_doc_from_file"},{"doc":"fireball","title":"post_doc_from_string","content":"pub fn post_doc_from_string(\n  apikey apikey: String,\n  apiver apiver: String,\n  database database: String,\n  collection_path collection_path: String,\n  doc_path doc_path: String,\n  input_data input_data: String,\n  proj_id proj_id: String,\n) -&gt; Result(FireballDocument, FireballError)\nput_file function to create a document in Google&#39;s Firestore Database\nSynonyms:\nfireball.post_doc_from_string\nfireball post_doc_from_string","url":"fireball.html#post_doc_from_string"},{"doc":"fireball","title":"post_file","content":"pub fn post_file(\n  apiver apiver: String,\n  apikey apikey: String,\n  infile infile: String,\n  outfile outfile: String,\n  proj_id proj_id: String,\n) -&gt; Result(String, FireballError)\nThis will change in the future if a native Multipart Form encoder is written for HTTPC\nSynonyms:\nfireball.post_file\nfireball post_file","url":"fireball.html#post_file"},{"doc":"fireball","title":"post_file_erl","content":"pub fn post_file_erl(\n  url url: String,\n  infile infile: String,\n) -&gt; Nil\npost_file_erl function is used to call erlang&#39;s inets and ssl funtions to send the request over httpc\nSynonyms:\nfireball.post_file_erl\nfireball post_file_erl","url":"fireball.html#post_file_erl"},{"doc":"fireball","title":"post_file_external","content":"pub fn post_file_external(\n  apiver apiver: String,\n  apikey apikey: String,\n  infile infile: String,\n  outfile outfile: String,\n  proj_id proj_id: String,\n  external_script external_script: String,\n  wd wd: String,\n) -&gt; Result(String, FireballError)\npost_file, but uses system cURL instead of native libaries\nSynonyms:\nfireball.post_file_external\nfireball post_file_external","url":"fireball.html#post_file_external"},{"doc":"fireball","title":"upload_data_to_json","content":"pub fn upload_data_to_json(\n  upload_data upload_data: UploadData,\n) -&gt; String\nA function to turn UploadData into JSON\nSynonyms:\nfireball.upload_data_to_json\nfireball upload_data_to_json","url":"fireball.html#upload_data_to_json"},{"doc":"fireball","title":"fireball","content":"","url":"fireball.html"}]);